__author__ = 'Robert Ancell <bob27@users.sourceforge.net>'
__license__ = 'GNU General Public License Version 2'
__copyright__ = 'Copyright 2005-2006  Robert Ancell'

import game
import cecp

class AIProfile:
    """
    """
    
    executable = None
    arguments = None
    
    def __init__(self, name, executable, arguments = []):
        """
        """
        self.__name = name
        self.executable = executable
        self.arguments = arguments
        
    def getName(self):
        """
        """
        return self.__name

class AIPlayer(game.ChessPlayer, cecp.CECPConnection):
    """
    """
    
    # The profile we are using
    __profile = None
    
    def __init__(self, name, profile):
        """Constructor for an AI player.
        
        'name' is the name of the player (string).
        'profile' is the profile to use for the AI (AIProfile).
        """
        self.__profile = profile

        game.ChessPlayer.__init__(self, name)
        cecp.CECPConnection.__init__(self, profile.executable, profile.arguments)
        
    def getProfile(self):
        """
        """
        return self.__profile
        
    def tick(self):
        """
        """
        self.read()
        
    def onAIMove(self, move):
        """Called by cecp.CECPConnection"""
        print 'AI moves: ' + move
        self.move(move)

    def onPlayerMoved(self, player, move):
        """Called by game.ChessPlayer"""
        self.reportMove(move.canMove)
    
    def readyToMove(self):
        """Called by game.ChessPlayer"""
        self.requestMove()
        
    def onGameEnded(self, winningPlayer = None):
        """Called by game.ChessPlayer"""
        self.quit()
